<?php
/**
* Class and Function List:
* Function list:
* - execute()
* - outputCSV()
* - insert_data()
* - config()
* Classes list:
* - CsvExportGH extends \
*/

/**
 * CHRONOFORMS version 4.0
 * Copyright (c) 2006 - 2011 Chrono_Man, ChronoEngine.com. All rights reserved.
 * Author: Chrono_Man (ChronoEngine.com)
 * @license    GNU/GPL
 * Visit http://www.ChronoEngine.com for regular updates and information.
 *
 */
namespace GCore\Admin\Extensions\Chronoforms\Actions\CsvExportGH;

/* @copyright:ChronoEngine.com @license:GPLv2 */
defined('_JEXEC') or die('Restricted access');
defined('GCORE_SITE') or die;

class CsvExportGH extends \GCore\Admin\Extensions\Chronoforms\Action
{
  static $title    = 'CSV Export [GH]';
  static $group    = array(
    'gh_actions' => '[GH] Custom Actions'
  );
  static $info = array(
    'title' => 'CSV Export [GH]',
    'content' => 'An advanced, customisable CSV Export action.'
  );

  var $defaults = array(
    'add_titles'          => true,
    'columns'             => '',
    'data_path'           => '',
    'delimiter'           => ',',
    'download_export'     => '',
    'download_mime_type'  => '',
    'download_nosave'     => false,
    'enclosure'           => '"',
    'exclude'             => '',
    'excluded_columns'    => '',
    'file_name'           => '',
    'include'             => '',
    'order_by'            => '',
    'post_file_name'      => 'csv_export',
    'remove_breaks'       => null,
    'save_path'           => '',
    'tablename'           => '',
    'tablename_dynamic'   => '',
    'where'               => '',
  );

  function execute(&$form, $action_id) {
    $config   = $form->actions_config[$action_id];
    $config   = new \GCore\Libs\Parameter($config);
    //echo'<div>$config[params]: '.print_r($config->params, true).'</div>';
    if ( !$config->get('enabled') ) {
      return;
    }
    $params = $config->params;


    $skip_list = array();
    foreach ( $this->defaults as $k => $v ) {
      if ( in_array( $k, $skip_list ) ) {
        continue;
      }
      if ( !isset($params[$k]) ) {
        // if the param isn't set use the default value
        $params[$k] = $v;
      } else {
        $params[$k] = trim($params[$k]);
        if ( !$params[$k] ) {
          // if the param has no value use the default value
          $params[$k] = $v;
        }
      }
      $$k = $params[$k];
    }

    $titles = array();

    // handle dynamic tablename
    if ( $tablename_dynamic && !$tablename ) {
      if ( isset($form->data[$tablename_dynamic]) && $form->data[$tablename_dynamic] ) {
        $db = \GCore\Libs\Database::getInstance();
        $tables = $db->getTablesList();
        $tablename_dynamic = $form->data[$tablename_dynamic];
        $tablename_dynamic = $db->_prefixTable($tablename_dynamic);
        if ( in_array($temp, $tables) ) {
          $tablename = $tablename_dynamic;
        } else {
          $form->errors['CSV Export [GH]'] = "Sorry, we couldn&rsquo;t find the table {$tablename_dynamic}.";
          $this->events['fail'] = 1;
          return;
        }
      }
    }

    // set the delimiter value
    if ( $delimiter == '##tab##' ) {
      $delimiter = chr( 9 );
    } elseif ( $delimiter == '##squote##' ) {
      $delimiter = chr( 39 );
    } elseif ( $delimiter ) {
      $delimiter = substr( $delimiter, 0, 1 );
    }

    // set the enclosure value
    if ( $enclosure ) {
      $enclosure = substr( $enclosure, 0, 1 );
    }

    $data = array();
    if ( $data_path ) {
      // get data from $form->data
      $data_path = explode('.', $data_path);
      $temp_file_name = $data_path[0];
      $data_found = \GCore\Libs\Arr::getVal($form->data,  $data_path, array());
      if ( !empty( $data_found ) && is_array( $data_found ) && $data_found === array_values( $data_found ) ) {
        $data = $data_found;
      }

      if ( $columns ) {
        //$columns  = array_keys($data[0]);
        //$titles   = array_combine($columns, $columns);
      }
    } elseif ( $tablename ) {
      // get data from table
      \GCore\Libs\Model::generateModel('ListData', array(
        'tablename' => $tablename
      ));
      $list_model = '\GCore\Models\ListData';
      $app = \JFactory::getApplication();

      if ( $columns ) {
        $columns  = \GCore\Libs\Str::list_to_array($columns);
        $titles   = array_keys($columns);
        $columns  = array_combine($columns, $columns);
      } else {
        $columns  = $list_model::getInstance()->dbo->getTableColumns($tablename);
        $titles   = array_combine($columns, $columns);
      }

      if ( $where ) {
        $where = \GCore\Libs\Str::replacer($where, $form->data);
        $where = eval('?>'.$where);
      }
      $form->data['debug']['where'] = $where;
      if ( $order_by ) {
        $order_by = array_map( 'trim', explode(',', $order_by) );
      } else {
        $order_by = $list_model::getInstance()->pkey;
      }

      $temp_file_name  = $tablename;
      $data = array();
      $data = $list_model::getInstance()->find('all', array(
        'fields'      => $columns,
        'conditions'  => $where,
        'order'       => $order_by
      ));
      foreach ( $data as $k => $v ) {
        $data[$k] = $v['ListData'];
      }
    }
    ////
    $curly_array = array(
      'form_name'     => $form->form['Form']['title'],
      'table_name'    => $tablename,
      'random'        => rand( 100000, 999999 ),
      'datetime'      => date( 'YmdHi' ),
      'directory'     => getcwd()
    );
    $curly_array = array_merge($form->data, $curly_array);
   if ( empty($file_name) ) {
      $file_name = "csv_export_{$temp_file_name}_{$curly_array['datetime']}.csv";
    } else {
      $file_name = \GCore\Libs\Str::replacer($file_name, $curly_array);
    }
    $file_name = \GCore\Libs\File::makeSafe($file_name);
    if ( pathinfo($file_name, PATHINFO_EXTENSION) != 'csv' ) {
      $file_name .= '.csv';
    }
 
    if ( $excluded_columns && !is_array($excluded_columns) ) {
      $excluded_columns = array_map('trim', explode("\n", $excluded_columns));
      $columns          = array_diff($columns, $excluded_columns);
    }

    $dir = getcwd();
    if ( empty($save_path) ) {
      $save_path = $dir.'/components/com_chronoforms5/uploads/cvs_export/';
    } else {
      $save_path = \GCore\Libs\Str::replacer($save_path, $curly_array);
      $prefix = strpos($save_path, $dir);
      if ( $prefix === false || $prefix > 0 ) {
        $save_path = $dir.'/'.$save_path;
      }
      $save_path .= '/';
      $save_path = str_replace('//', '/', $save_path);
    }
 
    // check if folder exists and is writeable
    if ( !file_exists($save_path.'index.html') ) {
      if ( !\GCore\Libs\Folder::create($save_path) ) {
        $form->errors['CSV Export [GH]'] = "Sorry, we couldn&rsquo;t create the upload directory: {$save_path}";
        $this->events['fail'] = 1;
        return;
      }
      $dummy_c = '<html><body bgcolor="#ffffff"></body></html>';
      if ( !\GCore\Libs\File::write($save_path.'index.html', $dummy_c)){
        $form->errors['CSV Export [GH]'] = "Sorry, we couldn&rsquo;t write to the upload directory.";
        $this->events['fail'] = 1;
        return;
      }
    }
    $output = '';
    if ( $download_nosave ) {
      // output up to 5MB is kept in memory, if it becomes bigger
      // it will automatically be written to a temporary file
      $csv = fopen( 'php://temp/maxmemory:'. ( 5*1024*1024 ), 'r+' );

      if ( $add_titles && count($titles) > 0 ) {
        fputcsv( $csv, $titles, $delimiter, $enclosure );
      }
      foreach ( $data as $d ) {
        if ( count($d) < 1 ) {
          continue;
        }
        if ( $remove_breaks ) {
          $d = $this->removeCR($d);
        }
        fputcsv( $csv, $d, $delimiter, $enclosure );
      }
      rewind( $csv );
      // put it all in a variable
      $output = stream_get_contents( $csv );
      $filesize = strlen( $output );
    } else {
      // file save
     $file = fopen( $save_path.$file_name, 'w' );
      if ( $file === false ) {
        $form->errors['CSV Export [GH]'] = 'Unable to open the file.';
        return;
      }
      if ( $add_titles  && count($titles) > 0 ) {
        fputcsv( $file, $titles, $delimiter, $enclosure );
      }
      // add data rows to the file
      foreach ( $data as $d ) {
        if ( count($d) < 1 ) {
          continue;
        }
        if ( $remove_breaks ) {
          $d = $this->removeCR($d);
        }
        fputcsv( $file, $d, $delimiter, $enclosure );
      }
      fclose( $file );
      // Get file URL and save to the form data
      $save_url                    = str_replace( JPATH_SITE.DIRECTORY_SEPARATOR, \JURI::root(), $save_path );
      $save_url                    = str_replace( DIRECTORY_SEPARATOR, '/', $save_url );
      $form->debug['CSV Export'][] = 'Save link is: <br />'.$save_url.$file_name;
      $form->data['csv_link']      = $save_url.$file_name;
      $form->data['csv_count']     = count( $data );
      $filesize                    = filesize( $save_path.$file_name );
      $form->data['csv_size']      = $filesize/1000;
      if ( $form->data['csv_size'] > 0 && $form->data['csv_size'] < 1 ) {
        $form->data['csv_size']  = number_format( $form->data['csv_size'], 1 );
      } else {
        $form->data['csv_size']  = number_format( $form->data['csv_size'], 0 );
      }
        $form->debug['CSV Export'][] = 'File size is: '.$form->data['csv_size'].' kb';
      }
    //add details under the post file name
    if ( !$download_nosave && $post_file_name ) {
      $form->data[$post_file_name]  = $file_name;
      $form->files[$post_file_name] = array(
        'name' => $file_name,
        'path' => $save_path.$file_name,
        'size' => $form->data['csv_size']
      );
      $form->files[$post_file_name]['link'] = $save_url.$file_name;
    }

    if ( $download_export || $download_nosave ) {
      // if Immediate download is checked
      \jimport( 'joomla.environment.browser' );
      $browser = \JBrowser::getInstance();

      switch ( $browser->getBrowser() ) {
      case 'msie':
        $inline = 'inline';
        $pragma = 'public';
        break;
      default:
        $inline = 'attachment';
        $pragma = 'no-cache';
        break;
      }
      $mimetype = 'text/csv';
      if ( $download_mime_type ) {
        switch ( $browser->getBrowser() ) {
          case 'msie':
            $mimetype = 'application/octetstream';
          case 'opera':
            $mimetype = 'application/octetstream';
            break;
          default:
            $mimetype = 'application/octet-stream';
            break;
        }
      }
      @ob_end_clean();
      ob_start();
      header( "Content-Type: {$mimetype}; charset=UTF-8" );
      header( 'Expires: '.gmdate( 'D, d M Y H:i:s' ).' GMT' );
      header( "Content-Disposition: {$inline}; filename={$file_name}" );
      header( "Content-Length: ".$filesize );
      if ( $browser->getBrowser() == 'msie' ) {
        header( 'Cache-Control: must-revalidate, post-check=0, pre-check=0' );
      }
      header( "Pragma: {$pragma}" );
      ob_clean();
      flush();
      if ( $download_nosave ) {
        print( $output );
      } else {
        readfile( $save_path.$file_name );
      }
      exit();
    }
  }

  private static function removeCR($data) {
    if ( !is_array($data) || count($data) == 0 ) {
      return false;
    }
    foreach ( $data as $k => $v ) {
      if ( strpos($v, "\r" ) !== false ) {
        $v = trim($v);
        $data[$k] = str_replace(array("\n", "\r"), ' ', $v);
      }
    }
    return $data;
  }

  public static
  function outputCSV($data) {
    $outstream = fopen('php://output', 'w');
    array_walk($data, array(
      'self',
      'insert_data'
    ) , $outstream);
    fclose($outstream);
  }

  public static
  function insert_data(&$vals, $key, $filehandler) {
    fputcsv($filehandler, $vals);
     // add parameters if you want
  }
    // :: The function below builds the action admin form ::
  public static
  function config() {
    require dirname(__FILE__).'/config.php';
  }

  public static
  function config_check($data = array()) {
    $diags = array();
    $diags[l_('Enabled')] = !empty($data['enabled']);
    return $diags;
  }
}
?>
